## pmdk 1.12.1

=== src/benchmarks/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2022, Intel Corporation

#
# src/benchmarks/Makefile -- build all benchmarks
#
TOP := $(dir $(lastword $(MAKEFILE_LIST)))../..

include $(TOP)/src/common.inc

vpath %.c $(TOP)/src/examples/libpmemobj/tree_map
vpath %.c $(TOP)/src/examples/libpmemobj/map
vpath %.c $(TOP)/src/examples/libpmemobj/hashmap

vpath %.c $(TOP)/src/libpmemobj
vpath %.c $(TOP)/src/common
vpath %.c $(TOP)/src/librpmem
vpath %.c $(TOP)/src/rpmem_common
vpath %.c $(TOP)/src/libpmempool

BENCHMARK = pmembench

GLIB:= $(call check_package, glib-2.0)
ifeq ($(GLIB),y)
TARGET = $(BENCHMARK)
else
$(info NOTE: Skipping pmembench because glib-2.0 is missing \
-- see src/benchmarks/README for details.)
endif

all: $(TARGET)

SRC=pmembench.cpp\
    benchmark_time.cpp\
    benchmark_worker.cpp\
    clo.cpp\
    clo_vec.cpp\
    config_reader.cpp\
    scenario.cpp\
    log.cpp\
    blk.cpp\
    pmem_memset.cpp\
    pmem_memcpy.cpp\
    pmem_flush.cpp\
    pmemobj_gen.cpp\
    pmemobj_persist.cpp\
    obj_pmalloc.cpp\
    obj_locks.cpp\
    obj_lanes.cpp\
    map_bench.cpp\
    pmemobj_tx.cpp\
    pmemobj_atomic_lists.cpp\
    poolset_util.cpp\
    benchmark_empty.cpp\
    pmemobj_tx_add_range.cpp

# Configuration file without the .cfg extension
CONFIGS=pmembench_log\
	pmembench_blk\
	pmembench_memset\
	pmembench_memcpy\
	pmembench_flush\
	pmembench_obj_pmalloc\
	pmembench_obj_persist\
	pmembench_obj_gen\
	pmembench_obj_locks\
	pmembench_obj_lanes\
	pmembench_map\
	pmembench_tx\
	pmembench_atomic_lists

OBJS=$(SRC:.cpp=.o)
ifneq ($(filter 1 2, $(CSTYLEON)),)
TMP_HEADERS := $(addsuffix tmp, $(HEADERS))
endif
LDFLAGS = -L$(LIBS_PATH) $(OS_LIBS)
LDFLAGS += -L../examples/libpmemobj/map
LDFLAGS += $(EXTRA_LDFLAGS)
ifeq ($(DEBUG),)
LIBS += ../nondebug/libpmemcore.a
LIBS += ../nondebug/libpmemcommon.a
else
LIBS += ../debug/libpmemcore.a
LIBS += ../debug/libpmemcommon.a
endif
CFLAGS += $(LIBNDCTL_CFLAGS)
LIBS += -lpmemobj -lpmemlog -lpmemblk -lpmempool -lpmem -pthread -lm \
	$(LIBDL) $(LIBUUID) $(LIBNDCTL_LIBS)
ifeq ($(LIBRT_NEEDED), y)
LIBS += -lrt
endif

CXXFLAGS = -Wall
CXXFLAGS += -Werror
CXXFLAGS += -std=c++11
CXXFLAGS += -Wno-invalid-offsetof
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wunused-macros
CXXFLAGS += -pthread
CXXFLAGS += -I../include
CXXFLAGS += -I../libpmemobj
CXXFLAGS += -I../common
CXXFLAGS += -I../core
CXXFLAGS += -I../examples/libpmemobj/map
CXXFLAGS += -I../rpmem_common
CXXFLAGS += -I../librpmem
CXXFLAGS += $(OS_INCS)
CXXFLAGS += -DSRCVERSION='"$(SRCVERSION)"'

ifeq ($(OS_DIMM),ndctl)
CXXFLAGS += -DSDS_ENABLED
endif

ifeq ($(COVERAGE),1)
CXXFLAGS += $(GCOV_CFLAGS)
LDFLAGS += $(GCOV_LDFLAGS)
LIBS += $(GCOV_LIBS)
endif

ifneq ($(SANITIZE),)
CXXFLAGS += -fsanitize=$(SANITIZE)
LDFLAGS += -fsanitize=$(SANITIZE)
endif

ifeq ($(BUILD_RPMEM),y)
SRC += rpmem.cpp
LIBS += -lrpmem $(LIBFABRIC_LIBS)
CONFIGS += pmembench_rpmem
CXXFLAGS += -DRPMEM_AVAILABLE
# Librpmem is deprecated.
# This flag allows to build tests, examples and benchmarks
# using rpmem despite the deprecated state.
CXXFLAGS += -Wno-deprecated-declarations
else
$(info NOTE: Skipping librpmem benchmark because $(BUILD_RPMEM_INFO))
endif

ifeq ($(GLIB),y)
CXXFLAGS += $(shell $(PKG_CONFIG) --cflags glib-2.0)
LIBS += $(shell $(PKG_CONFIG) --libs glib-2.0)
endif

LIBMAP_DIR=../examples/libpmemobj/map
LIBMAP=$(LIBMAP_DIR)/libmap.a

OBJS += pmemobj.o

ifeq ($(DEBUG),)
CXXFLAGS += -O3
LIBS_PATH=../nondebug
else
CXXFLAGS += -ggdb
LIBS_PATH=../debug
endif

GLIB_TEST_PROG="\#include <glib.h>\nint main(){return 0;}"
GLIB_SILENCE := $(shell printf $(GLIB_TEST_PROG) |\
	$(CXX) $(CXXFLAGS) -x c -o /dev/null - 2>/dev/null && echo n || echo y)

ifeq ($(GLIB_SILENCE), y)
CXXFLAGS += -Wno-unknown-attributes
endif

CXXFLAGS += $(EXTRA_CXXFLAGS)

objdir=.

%.o: %.cpp Makefile
	$(call check-cstyle, $<)
	@mkdir -p .deps
	$(CXX) -MD -c -o $@ $(CXXFLAGS) $(call coverage-path, $<)
	$(call check-os, $@, $<)
	$(create-deps)

%.htmp: %.h
	$(call check-cstyle, $<, $@)

%.hpptmp: %.hpp
	$(call check-cstyle, $<, $@)

$(BENCHMARK): $(TMP_HEADERS) $(OBJS) $(LIBMAP)
	$(CXX) -o $@ $(LDFLAGS) $(OBJS) $(LIBMAP) $(LIBS)

$(LIBMAP):
	$(MAKE) -C $(LIBMAP_DIR) map

clean:
	$(RM) $(OBJS) $(TMP_HEADERS)
	$(RM) *.csv

clobber: clean
	$(RM) $(BENCHMARK)
	$(RM) *.csv
	$(RM) -r .deps

$(CONFIGS):
	LD_LIBRARY_PATH=$(LIBS_PATH) ./$(BENCHMARK) $@.cfg > $@.csv

run: $(BENCHMARK) $(CONFIGS)

sparse:

.PHONY: all clean clobber run $(CONFIGS)

PMEMOBJ_SYMBOLS=pmalloc pfree lane_hold lane_release

pmemobj.o: $(LIBS_PATH)/libpmemobj/libpmemobj_unscoped.o
	$(OBJCOPY) --localize-hidden $(addprefix -G, $(PMEMOBJ_SYMBOLS)) $< $@

-include .deps/*.P

=== src/examples/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2021, Intel Corporation

#
# examples/Makefile -- build the Persistent Memory Development Kit examples
#

include ../common.inc

DIRS = libpmem libpmemblk libpmemlog libpmemobj librpmem libpmempool \
	pmreorder libpmem2 libpmemset

include Makefile.inc

rmtmp:
	$(RM) $(TMP_HEADERS)

clobber clean: rmtmp

=== src/libpmem/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2022, Intel Corporation

#
# src/libpmem/Makefile -- Makefile for libpmem
#

include ../common.inc

LIBRARY_NAME = pmem
LIBRARY_SO_VERSION = 1
LIBRARY_VERSION = 0.0
SOURCE =\
	$(CORE)/alloc.c\
	$(CORE)/fs_posix.c\
	$(CORE)/os_posix.c\
	$(CORE)/os_thread_posix.c\
	$(CORE)/out.c\
	$(CORE)/util.c\
	$(CORE)/util_posix.c\
	$(COMMON)/file.c\
	$(COMMON)/file_posix.c\
	$(COMMON)/mmap.c\
	$(COMMON)/mmap_posix.c\
	$(COMMON)/os_deep_linux.c\
	libpmem.c\
	memops_generic.c\
	pmem.c\
	pmem_posix.c\
	$(PMEM2)/pmem2_utils.c\
	$(PMEM2)/config.c\
	$(PMEM2)/persist_posix.c\
	$(PMEM2)/source.c\
	$(PMEM2)/source_posix.c

ifeq ($(OS_KERNEL_NAME),Linux)
SOURCE +=\
	$(PMEM2)/pmem2_utils_linux.c\
	$(PMEM2)/pmem2_utils_$(OS_DIMM).c\
	$(PMEM2)/auto_flush_linux.c\
	$(PMEM2)/deep_flush_linux.c
else
SOURCE +=\
	$(PMEM2)/pmem2_utils_other.c\
	$(PMEM2)/auto_flush_none.c\
	$(PMEM2)/deep_flush_other.c
endif

ifeq ($(OS_DIMM),ndctl)
SOURCE +=\
	region_namespace_ndctl.c\
	numa_ndctl.c
CFLAGS += $(LIBNDCTL_CFLAGS)
LIBS += $(LIBNDCTL_LIBS)
else
SOURCE +=\
	region_namespace_none.c\
	numa_none.c
endif

INCS += -I$(TOP)/src/libpmem2

include ../libpmem2/$(ARCH)/sources.inc

SOURCE += $(LIBPMEM2_ARCH_SOURCE)

include ../Makefile.inc

include $(PMEM2)/$(ARCH)/flags.inc

CFLAGS += -I. $(MINIASYNC_CFLAGS)
LIBS += -pthread

=== src/libpmemlog/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2022, Intel Corporation

#
# src/libpmemlog/Makefile -- Makefile for libpmemlog
#

LIBRARY_NAME = pmemlog
LIBRARY_SO_VERSION = 1
LIBRARY_VERSION = 0.0

include ../core/pmemcore.inc
include ../common/pmemcommon.inc

SOURCE +=\
	libpmemlog.c\
	log.c

include ../Makefile.inc

CFLAGS += $(LIBNDCTL_CFLAGS) $(MINIASYNC_CFLAGS) -DPMEM2_USE_MINIASYNC=1

LIBS += -pthread -lpmem $(LIBNDCTL_LIBS)

=== src/deps/miniasync/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2021-2022, Intel Corporation
#

cmake_minimum_required(VERSION 3.3)

project(miniasync C)
set(MINIASYNC_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/out CACHE STRING "")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/out CACHE STRING "")

set(VERSION_MAJOR 0)
set(VERSION_MINOR 1)
set(VERSION_PATCH 0)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

set(MINIASYNC_SOURCE_DIR ${MINIASYNC_ROOT_DIR}/src)
set(MINIASYNC_INCLUDE_DIR ${MINIASYNC_ROOT_DIR}/src/include)
set(EXAMPLES_DIR ${MINIASYNC_ROOT_DIR}/examples/)
set(CORE_SOURCE_DIR ${MINIASYNC_SOURCE_DIR}/core)
set(MINIASYNC_DML_SOURCE_DIR ${MINIASYNC_ROOT_DIR}/extras/dml)
set(MINIASYNC_DML_INCLUDE_DIR ${MINIASYNC_ROOT_DIR}/extras/dml/include)

set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
set(TEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/test
	CACHE STRING "working directory for tests")

if(WIN32)
	set(MINIASYNC_INCLUDE_DIR_WIN ${CMAKE_SOURCE_DIR}/src/windows/include/)
endif()

option(COVERAGE "run coverage test" OFF)
option(DEVELOPER_MODE "enable developer checks" OFF)
option(CHECK_CSTYLE "check code style of C sources" OFF)
option(TRACE_TESTS "more verbose test outputs" OFF)
option(USE_ASAN "enable AddressSanitizer (debugging)" OFF)
option(USE_UBSAN "enable UndefinedBehaviorSanitizer (debugging)" OFF)
option(BUILD_DOC "build documentation" ON)
option(BUILD_EXAMPLES "build examples" ON)
option(BUILD_TESTS "build tests" ON)
option(TESTS_USE_VALGRIND "enable tests with valgrind (if found)" ON)
option(COMPILE_DML "compile miniasync dml implementation library" OFF)

include(FindPerl)
include(FindThreads)
include(CMakePackageConfigHelpers)
include(CheckCCompilerFlag)
include(GNUInstallDirs)
include(${CMAKE_SOURCE_DIR}/cmake/functions.cmake)

# look for pkg config (use it later for managing valgrind)
if(NOT WIN32)
	find_package(PkgConfig REQUIRED)
endif()

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Debug")
endif()

if(NOT PERL_FOUND)
	message(FATAL_ERROR "Perl not found")
endif()

add_custom_target(checkers ALL)
add_custom_target(cstyle)
add_custom_target(check-whitespace)
add_custom_target(check-license
	COMMAND ${CMAKE_SOURCE_DIR}/utils/check_license/check-headers.sh
		${CMAKE_SOURCE_DIR}
		BSD-3-Clause)

add_custom_target(check-commits
	COMMAND ${CMAKE_SOURCE_DIR}/utils/check-commits.sh)

add_custom_target(check-whitespace-main
	COMMAND ${PERL_EXECUTABLE}
		${CMAKE_SOURCE_DIR}/utils/check_whitespace
		${CMAKE_SOURCE_DIR}/README.md
		${CMAKE_SOURCE_DIR}/LICENSE)

add_dependencies(check-whitespace check-whitespace-main)

# add compiler flags using macro defined in the functions.cmake file
add_flag(-Wpointer-arith)
add_flag(-Wunused-macros)
add_flag(-Wsign-conversion)
add_flag(-Wsign-compare)
add_flag(-Wunreachable-code-return)
add_flag(-Wmissing-variable-declarations)
add_flag(-fno-common)
add_flag(-std=gnu99)
add_flag(-ggdb DEBUG)
add_flag(-DDEBUG DEBUG)
add_flag("-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2" RELEASE)

if(WIN32)
# It looks like the issue is still unfixed:
# https://developercommunity.visualstudio.com/t/several-warnings-in-windows-sdk-100177630-in-windo/435362
	add_flag(-DWIN32_LEAN_AND_MEAN)
	add_compile_options(/W3 /WX)
endif()

if(USE_ASAN)
	add_sanitizer_flag(address)
endif()

if(USE_UBSAN)
	add_sanitizer_flag(undefined)
endif()

if(COVERAGE)
       set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -coverage")
endif()

if(DEVELOPER_MODE)
	add_flag(-Wall)
	add_flag(-Werror)

	if(CHECK_CSTYLE)
		add_dependencies(checkers cstyle)
	endif()
	add_dependencies(checkers check-whitespace)
	add_dependencies(checkers check-license)
	add_dependencies(checkers check-commits)
endif()

# add checkers for the root CMakeLists file and for cmake helper files
add_check_whitespace(cmake-main ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt)
add_check_whitespace(cmake-helpers "${CMAKE_CURRENT_SOURCE_DIR}/cmake/*[.cmake]")

# add checkers for utils and subdirectories
add_check_whitespace(utils-all
		${CMAKE_CURRENT_SOURCE_DIR}/utils/*
		${CMAKE_CURRENT_SOURCE_DIR}/utils/check_license/*
		${CMAKE_CURRENT_SOURCE_DIR}/utils/docker/*
		${CMAKE_CURRENT_SOURCE_DIR}/utils/docker/images/*
		${CMAKE_CURRENT_SOURCE_DIR}/utils/md2man/*)

# look for and enable valgrind
if(NOT WIN32)
	pkg_check_modules(VALGRIND valgrind)
endif()

configure_file(${CMAKE_SOURCE_DIR}/cmake/libminiasync.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/libminiasync.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libminiasync.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

configure_file(
	"${MINIASYNC_ROOT_DIR}/cmake/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

configure_package_config_file(${CMAKE_SOURCE_DIR}/cmake/libminiasync-config.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/libminiasync-config.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/libminiasync/cmake
	PATH_VARS CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)

write_basic_package_version_file(libminiasync-config-version.cmake
				VERSION ${VERSION}
				COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libminiasync-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/libminiasync-config-version.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/libminiasync/cmake)

if(VALGRIND_FOUND)
	add_flag(-DVG_MEMCHECK_ENABLED=1)
	add_flag(-DVG_DRD_ENABLED=1)
	add_flag(-DVG_HELGRIND_ENABLED=1)

	include_directories(${VALGRIND_INCLUDE_DIRS})
endif()

# add CMakeLists.txt from the src directory
add_subdirectory(src)

# add CMakeLists.txt from the tests directory
if(BUILD_TESTS)
	if(TEST_DIR)
		enable_testing()
	else()
		message(WARNING "TEST_DIR is empty - 'make test' will not work")
	endif()

	add_subdirectory(tests)
endif()

# add CMakeLists.txt from the examples directory
if(BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

# add CMakeLists.txt from the doc directory
if(BUILD_DOC)
	add_subdirectory(doc)
endif()

if(NOT "${CPACK_GENERATOR}" STREQUAL "")
	include(${CMAKE_SOURCE_DIR}/cmake/packages.cmake)
endif()

# add CMakeLists.txt from the extras dml directory
if (COMPILE_DML)
	add_subdirectory(extras/dml)
endif()

=== src/examples/libpmem2/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2021, Intel Corporation

#
# examples/libpmem2/Makefile -- build the libpmem2 examples
#

DIRS = advanced basic log redo map_multiple_files unsafe_shutdown ringbuf

include ../Makefile.inc

=== src/examples/libpmemset/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2021, Intel Corporation

#
# examples/libpmemset/Makefile -- build the libpmemset examples
#

DIRS = basic

include ../Makefile.inc

=== src/test/blk_include/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2016-2019, Intel Corporation

#
# src/test/blk_include/Makefile -- compilation test for libpmemblk
#
TARGET = blk_include
OBJS = blk_include.o

LIBPMEMBLK=y

include ../Makefile.inc

=== src/test/blk_recovery/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2019, Intel Corporation

#
# src/test/blk_recovery/Makefile -- build blk_recovery unit test
#
TARGET = blk_recovery
OBJS = blk_recovery.o

LIBPMEMBLK=y

include ../Makefile.inc
CFLAGS += -I../../libpmemblk

=== src/test/libpmempool_check_version/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2019, Intel Corporation

#
# src/test/libpmempool_check_version/Makefile -- build libpmempool_check_version unittest
#

TARGET = libpmempool_check_version
OBJS = libpmempool_check_version.o

LIBPMEMPOOL=y

include ../Makefile.inc

=== src/test/log_basic/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2019, Intel Corporation

#
# src/test/log_basic/Makefile -- build log_basic unit test
#
TARGET = log_basic
OBJS = log_basic.o

LIBPMEMLOG=y

include ../Makefile.inc

=== src/test/obj_ctl_stats/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2017-2019, Intel Corporation

#
# src/test/obj_ctl_stats/Makefile -- build obj_ctl_stats test
#
TARGET = obj_ctl_stats
OBJS = obj_ctl_stats.o

LIBPMEMOBJ=y

include ../Makefile.inc

=== debian/changelog ===
pmdk (1.12.1-2) unstable; urgency=medium

  * Fix the watch file wrt GitHub changes.
  * Drop librpmemd -- removed upstream for 1.13

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 09 Jan 2023 10:32:36 +0100

pmdk (1.12.1-1) unstable; urgency=medium

  * New upstream bugfix release.
  * dh 13.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 Aug 2022 14:09:14 +0200

=== debian/control ===
Source: pmdk
Section: libs
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: bash-completion,
               bc,
               cmake,
               ed,
               debhelper-compat (= 13),
               dh-exec,
               libdaxctl-dev (>= 64),
               libndctl-dev (>= 64),
               ndctl,
               pandoc,
               pkg-config,
               python3,
               strace,
               valgrind-if-available,
               valgrind (>= 1:3.15.0) [arm64],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://pmem.io/pmdk/
Vcs-Git: https://github.com/kilobyte/pmdk -b debian
Vcs-Browser: https://github.com/kilobyte/pmdk/tree/debian

Package: libpmem1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v1 runtime
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This library is provided for software which tracks every store to pmem and
 needs to flush those changes to durability.  Most developers will find higher
 level libraries like libpmemobj to be much more convenient.
 .
 This package provides binary runtime for version 1 of the API.

Package: libpmem1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library — debug build
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmem-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v1 headers
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains libraries and header files used for linking programs
 against libpmem.

Package: libpmem2
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v2 runtime
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This library is provided for software which tracks every store to pmem and
 needs to flush those changes to durability.  Most developers will find higher
 level libraries like libpmemobj to be much more convenient.

Package: libpmem2-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library — debug build
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmem2-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v2 headers
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains libraries and header files used for linking programs
 against libpmem2, with a modernized API that avoids certain limitations of
 libpmem1.

Package: libpmemblk1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory block array support library
 libpmemblk implements a pmem-resident array of blocks, all the same size, where
 a block is updated atomically with respect to power failure or program
 interruption (no torn blocks).
 .
 This library is provided for cases requiring large arrays of objects at least
 512 bytes each.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.

Package: libpmemblk1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory block array support library — debug build
 libpmemblk implements a pmem-resident array of blocks, all the same size, where
 a block is updated atomically with respect to power failure or program
 interruption (no torn blocks).
 .
 This library is provided for cases requiring large arrays of objects at least
 512 bytes each.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmemblk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmemblk1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmemblk1
 libpmemblk implements a pmem-resident array of blocks, all the same size, where
 a block is updated atomically with respect to power failure or program
 interruption (no torn blocks).
 .
 This package contains libraries and header files used for linking programs
 against libpmemblk.

Package: libpmemlog1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory log file support library
 libpmemlog implements a pmem-resident log file.
 .
 This library is provided for cases requiring an append-mostly file to record
 variable length entries.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.

Package: libpmemlog1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory log file support library — debug build
 libpmemlog implements a pmem-resident log file.
 .
 This library is provided for cases requiring an append-mostly file to record
 variable length entries.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmemlog-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmemlog1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmemlog1
 libpmemlog implements a pmem-resident log file.
 .
 This package contains libraries and header files used for linking programs
 against libpmemlog.

Package: libpmemobj1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory object store support library
 libpmemobj turns a persistent memory file into a flexible object store,
 supporting transactions, memory management, locking, lists, and a number of
 other features.

Package: libpmemobj1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory object store support library — debug build
 libpmemobj turns a persistent memory file into a flexible object store,
 supporting transactions, memory management, locking, lists, and a number of
 other features.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmemobj-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmemobj1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmemobj1
 libpmemobj turns a persistent memory file into a flexible object store,
 supporting transactions, memory management, locking, lists, and a number of
 other features.
 .
 This package contains libraries and header files used for linking programs
 against libpmemobj.

Package: libpmempool1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory pool management support library
 libpmempool provides a set of utilities for management, diagnostics and repair
 of persistent memory pools.  A pool in this context means a pmemobj pool,
 pmemblk pool, pmemlog pool or BTT layout, independent of the underlying
 storage.  The libpmempool is for applications that need high reliability or
 built-in troubleshooting.  It may be useful for testing and debugging purposes
 also.

Package: libpmempool1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory pool management support library — debug build
 libpmempool provides a set of utilities for management, diagnostics and repair
 of persistent memory pools.  A pool in this context means a pmemobj pool,
 pmemblk pool, pmemlog pool or BTT layout, independent of the underlying
 storage.  The libpmempool is for applications that need high reliability or
 built-in troubleshooting.  It may be useful for testing and debugging purposes
 also.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmempool-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmempool1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmempool1
 libpmempool provides a set of utilities for management, diagnostics and repair
 of persistent memory pools.
 .
 This package contains libraries and header files used for linking programs
 against libpmempool.

Package: pmdk-tools
Section: misc
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory management tools
 The main purpose of this package is to provide a user with a set of utilities
 for off-line analysis and manipulation of pools created by pmem libraries.
 .
 The utilities may be useful for troubleshooting by system administrators and
 for software developers who work on applications based on these libraries.  The

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_UPSTREAM_VERSION = $(shell dpkg-parsechangelog -S version | cut -d - -f 1 | cut -d : -f 2)

BUILD_ARGS = prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH) sysconfdir=/etc bashcompdir=/usr/share/bash-completion/completions NORPATH=1 BUILD_EXAMPLES=n BUILD_BENCHMARKS=n

%:
	dh $@ --with bash-completion

override_dh_auto_clean:
	dh_auto_clean
	rm -rf src/test/unittest/__pycache__/

override_dh_auto_build:
	+$(MAKE) doc
	for x in `grep -l _LOG_LEVEL doc/lib*/lib*.7`; do \
		ed -s <debian/man-debug.ed $$x; done
	dh_auto_build  -- $(BUILD_ARGS)

override_dh_auto_install:
	dh_auto_install -- $(BUILD_ARGS)

override_dh_install:
	mkdir -p debian/tmp/usr/share/pmdk/
	cp utils/pmdk.magic debian/tmp/usr/share/pmdk/
	dh_install

override_dh_installexamples:
	dh_installexamples --exclude=.gitignore --exclude=.vcxproj

override_dh_installman:
	dh_installman
	dh_installman -p pmdk-tools doc/rpmemd/*.1

override_dh_missing:
	dh_missing --list-missing --exclude=usr/share/man --exclude=usr/lib/$(DEB_HOST_MULTIARCH)/pmdk_debug/ --exclude=usr/share/bash-completion/completions/pmempool

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp debian/testconfig.* src/test/
	# Still fails/times out on weird setups (a 33GB fallocate).
	rm -f src/test/obj_pool/TEST34
	# binutils regression #964457
	rm -rf src/test/scope/TESTS.py
ifeq ($(DEB_BUILD_ARCH),ppc64el)
	# https://github.com/pmem/pmdk/issues/5458
	rm -f src/test/obj_ctl_arenas/TEST3 src/test/pmem2_future/TESTS.py
endif
	+$(MAKE) check pycheck $(BUILD_ARGS)
endif

=== debian/tests/control ===
Tests: manage-pools
Depends: pmdk-tools

Tests: daxio-version
Depends: pmdk-tools
Restrictions: allow-stderr

Tests: examples-libpmem
Depends: gcc, libc6-dev, libpmem-dev

Tests: examples-libpmem2
Depends: gcc, libc6-dev, libpmem2-dev

Tests: examples-libpmemblk
Depends: gcc, libc6-dev, libpmemblk-dev

Tests: examples-libpmemlog
Depends: gcc, libc6-dev, libpmemlog-dev

Tests: examples-libpmempool
Depends: gcc, libc6-dev, libpmempool-dev

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/,uversionmangle=s/-rc/~rc/" \
https://github.com/pmem/@PACKAGE@/tags/ (?:.*?/)?v?(\d[\d.]*)\.tar\..z
